var prefixes=new Array();
prefixes["_nonempty_"]=validate_nonempty;
prefixes["_email_"]=validate_email;
prefixes["_date_"]=validate_date;
prefixes["_time_"]=validate_time;
prefixes["_datetime_"]=validate_datetime;
prefixes["_number_"]=validate_number;
prefixes["_select_"]=validate_select;
prefixes["_radio_"]=validate_radio;
prefixes["_alphastring_"]=validate_alphastring;
prefixes["_login_"]=validate_login;
prefixes["_dirname_"]=validate_dirname;
//sautkin
prefixes["_nonumber_"]=validate_nonumber;
prefixes["_beforedate_"]=validate_beforedate;
prefixes["_before18date_"]=validate_before18date;
prefixes["_afterdate_"]=validate_afterdate;
//nomad
prefixes["_after65date_"]=validate_after65date;
prefixes["_digit_"]=validate_digit;
// pawigor
prefixes["_captcha_"]=validate_captcha;
//
//marhipov
prefixes["_nonemptyalt_"]=validate_nonemptyalt;
//
warnings=new Array();
warnings["_nonempty_"]="Не заполнено обязательное поле";
warnings["_email_"]="Неверный формат e-mail";
warnings["_date_"]="Неверный формат даты(DD.MM.YYYY)";
warnings["_time_"]="Неверный формат времени(HH:MM)";
warnings["_datetime_"]="Неверный формат даты и времени(DD.MM.YYYY HH:MM)";
warnings["_number_"]="Неверный формат числа";
warnings["_select_"]="Не выбрано поле";
warnings["_radio_"]="Не выбрано поле";
warnings["_alphastring_"]="Неверный формат(строка из латинских букв)";
warnings["_login_"]="Неверный формат(строка из цифр или латинских букв без пробелов)";
//sautkin
warnings["_nonumber_"]="Неверный формат(строка не должна содержать цифр)";
warnings["_beforedate_"]="Некорректная дата(не может быть больше текущей)";
warnings["_before18date_"]="Некорректная дата(Вам нет еще 18 лет)";
warnings["_afterdate_"]="Некорректная дата(не может быть меньше текущей)";
//nomad
warnings["_after65date_"]="Некорректная дата(Вам больше 65 лет)";
warnings["_digit_"]="Неверный формат(строка только из цифр)";
//pawigor 
warnings["_captcha_"]="CAPTCHA"
//
//marhipov
warnings["_nonemptyalt_"]="Не заполнено обязательное поле";
//
warnings["_dirname_"]="Неверный формат названия директории (строка из латинских букв без пробелов)";
//Eugene Chusov
warnings["_minlen_"]="Длина поля не менее {n} символов";
warnings["_maxlen_"]="Длина поля не более {n} символов";
var minlen = 0;
var maxlen = 0;
//

var checked_fields=new Array();
var GetPrefixPos=0;
var f;

function CheckMandatoryFields(form) {
	f=document.forms[form];
	var prefix;
	var c;
	var i;
	var flag=true;
	var element_name;
	var item;
	var form_length=f.elements.length;
	
	for(c=0;c<form_length;c++) {
		GetPrefixPos=0;
		item=f.elements[c];
		element_name=item.name;

//chusov4
//добавляем в массив префиксов minlenX и maxlenX,
//если они присутствуют в имени поля.
//без X ошибки не выдаст - но ограничивать не будет
//в имени поля должен быть только один minlenX или
//только один maxlenX или minlenX и maxlenX
//Может действовать на несколько полей
//при пустом поле minlenX отключается ( используйте _nonempty_ )

		var min = /_minlen(\d*)_/.exec(element_name);
		var max = /_maxlen(\d*)_/.exec(element_name);

		// if( min && !prefixes[min[0]] ){
		if( min ){
			minlen = min[1];
			if (!prefixes[min[0]]){
				prefixes[min[0]] = validateMin;
				warnings[min[0]] = warnings['_minlen_'].replace('{n}',minlen);
			}
		}

		// if( max && !prefixes[max[0]] ){
		if( max ){
			maxlen = max[1];
			if (!prefixes[max[0]]){
				prefixes[max[0]] = validateMax;
				warnings[max[0]] = warnings['_maxlen_'].replace('{n}',maxlen);
			}
		}
//
		while( ( prefix=getNextPrefix(element_name) )!= "" && !item.disabled) {
		    if(!(prefixes[prefix](item))) {
		        alert(warnings[prefix]);
				// marhipov Модифицировано для устранения ошибки при отправке формы со скрытыми полями
				var digits=f.elements[c].name.match("\\d+$");
				if(!f.elements.check_form_langs)
					f.elements[c].focus();
				else
					{
					if(f.elements.check_form_langs.value=="" || (!f.elements.check_form_langs.value.match("_"+digits+"_")))
						f.elements[c].focus();
					}
				//
				return false;
			}
		}
	}

	while(flag) {
		flag=false;
		for(c=0;c<form_length;c++) {
			element_name=f.elements[c].name;
			for(prefix in prefixes) {
				if(element_name.substring(0,prefix.length)==prefix) {
					f.elements[c].name=element_name.substring(prefix.length,element_name.length);
					flag=true;
				}
			}
		}
	}

	return true;
}

function getNextPrefix(name) {
	var prefix;
	for(prefix in prefixes) {
		if( name.substring(GetPrefixPos,GetPrefixPos+prefix.length) == prefix ) {
			GetPrefixPos+=prefix.length;
			return prefix;
		}
	}
	GetPrefixPos=0;
	prefix="";
	return prefix;
}

//marhipov
function validate_nonemptyalt(obj) {
	var name=obj.name;
	var new_name,i;
	new_name='f'+name.match(/\d+a\d+$/);
	for(i=0;i<f.elements.length;i++)
		if(f.elements[i].name==new_name || f.elements[i].name=="_radio_"+new_name)
			if(f.elements[i].value=='alt' && f.elements[i].checked=='1' && obj.value=='')
				return false;
	return true;
}
//

//Eugene Chusov 22.03.2007
function validateMax(obj){
	var len = obj.value.length;
		if( maxlen != 0 && len > maxlen ){
			return false;
		}
	return true;
}

//&& len - если поле пустое оно не обрабатывается
function validateMin(obj){
	var len = obj.value.length;
		if( minlen != 0 && len > 0 && len < minlen ){
			return false;
		}
	return true;
}
//

function validate_email(obj) {
	var i;
	var val=obj.value;
	var state=0;
	if(val=="") return true;

	var re;
	re = /^[\w\.-]+@[\w\.-]+\.\w\w+$/;
	if ( !obj.value.match(re) ) return false;
	return true;
}

function validate_date(obj) {
	var i,state=0;
	var val=obj.value;
	var dd="",mm="",yyyy="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==".") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else dd+=val.charAt(i);
				break;
			case 1:
				if(val.charAt(i)==".") state=2;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mm+=val.charAt(i);
				break;
			case 2:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else yyyy+=val.charAt(i);
		}
	}
	if(state!=2) return false;
	if(isNaN(parseInt(dd)) || isNaN(parseInt(mm)) || isNaN(parseInt(yyyy))) return false;
	if(dd.length != 2 || mm.length !=2 || yyyy.length != 4) return false;
	if(parseInt(dd) < 0 || parseInt(mm) < 0 || parseInt(dd) > 31 || parseInt(mm) > 12) return false;
	return true;
}

function validate_beforedate(obj) {
    if ( !validate_date(obj) ){
        return false;
    }
	var val=obj.value;
	if(val=="") return true;

    var dd = val.substr(0,2);
    var mm = val.substr(3,2);
    var yyyy = val.substr(6,4);
    var form_date = new Date(yyyy, mm-1, dd);
    var now = new Date();
    if ( now < form_date) return false;
    return true;
}

function validate_before18date(obj) {
    if ( !validate_date(obj) ){
        return false;
    }
	var val=obj.value;
	if(val=="") return true;

    var dd = val.substr(0,2);
    var mm = val.substr(3,2);
    var yyyy = val.substr(6,4);
    var form_date = new Date(yyyy*1+18, mm-1, dd);
    var now = new Date();
    //alert(now.toDateString() + ' | ' + form_date.toDateString() + '\n' + Date.parse(now.toDateString()) + '\n' + Date.parse(form_date.toDateString()));
    if ( now < form_date) return false;
    return true;
}

function validate_afterdate(obj) {
    if ( !validate_date(obj) ){
        return false;
    }
	var val=obj.value;
	if(val=="") return true;

    var dd = val.substr(0,2);
    var mm = val.substr(3,2);
    var yyyy = val.substr(6,4);
    var form_date = new Date(yyyy, mm-1, dd);
    var now = new Date();
    if ( now > form_date) return false;
    return true;
}

function validate_after65date(obj) {
    if ( !validate_date(obj) ){
        return false;
    }
	var val=obj.value;
	if(val=="") return true;

    var dd = val.substr(0,2);
    var mm = val.substr(3,2);
    var yyyy = val.substr(6,4);
    var form_date = new Date(yyyy*1+65, mm-1, dd);
    var now = new Date();
    //alert(now.toDateString() + ' | ' + form_date.toDateString() + '\n' + Date.parse(now.toDateString()) + '\n' + Date.parse(form_date.toDateString()));
    if ( now > form_date) return false;
    return true;
}

function validate_time(obj) {
	var i,state=0;
	var val=obj.value;
	var hh="",mi="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==":") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else hh+=val.charAt(i);
				break;
			case 1:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mi+=val.charAt(i);
		}
	}
	if(state!=1) return false;
	if(isNaN(parseInt(hh)) || isNaN(parseInt(mi))) return false;
//marhipov
	if(hh.length != 2 || mi.length !=2) return false;
//
	if(parseInt(hh)>23 || parseInt(mi)<0 || parseInt(mi)>59 || parseInt(mi)<0) return false;
	return true;
}


function validate_datetime(obj) {
	var i,state=0;
	var val=obj.value;
	var dd="",mm="",yyyy="",hh="",mi="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==".") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else dd+=val.charAt(i);
				break;
			case 1:
				if(val.charAt(i)==".") state=2;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mm+=val.charAt(i);
				break;
			case 2:
				if(val.charAt(i)==" ") state=3;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else yyyy+=val.charAt(i);
				break;
			case 3:
				if(val.charAt(i)==":") state=4;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else hh+=val.charAt(i);
				break;
			case 4:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mi+=val.charAt(i);
		}
	}
	if(state!=4) return false;

	if(isNaN(parseInt(dd)) || isNaN(parseInt(mm)) || isNaN(parseInt(yyyy))) return false;
	if(parseInt(dd) < 0 || parseInt(mm) < 0 || parseInt(dd) > 31 || parseInt(mm) > 12) return false;
	if(isNaN(parseInt(hh)) || isNaN(parseInt(mi))) return false;
//marhipov
	if(hh.length != 2 || mi.length !=2) return false;
//
	if(parseInt(hh)>23 || parseInt(mi)<0 || parseInt(mi)>59 || parseInt(mi)<0) return false;
	return true;
}

function validate_nonempty(obj) {
	var val=obj.value;
	if(val.replace(/(^\s*)|(\s*$)/g, "")=="") return false;
	return true;
}

function validate_number(obj) {
//Измения: исправлен баг проверки на число
//Дата изменения: 30.10.2003 17:51
//Автор: Архипов Максим и Холодий Андрей

	if (obj.value == "") return true;
	var re;
	re = /^[+-]?\d+[\.,]?\d*$/;
	if ( !obj.value.match(re) ) return false;
	return true;
}

function validate_digit(obj) {
//nomad - можно использовать только цифры
	if (obj.value == "") return true;
	var re;
	re = /^\d*$/;
	if ( !obj.value.match(re) ) return false;
	return true;
}

function validate_select(obj) {
	var val=obj.options[obj.selectedIndex].value;
	if(val==-1 || val=="") return false;
	return true;
}

function validate_radio(obj) {
	var obj_name=obj.name;
	obj = f[obj.name];
	if(checked_fields[obj_name]==true){
		return true;
	}
	var status=false;
	var obj_length=obj.length;
	for (var i = 0;i<obj_length; i++){
   		if (obj[i].checked){
			status=true;
		}
	}
	if(status){
		checked_fields[obj_name]=true;
	}
	return status;
}

function validate_alphastring(obj) {
	var val=obj.value;
	for(i=0;i<val.length;i++) {
        	if(!is_alpha(val.charAt(i))&&!is_number(val.charAt(i))&&!is_addsymb(val.charAt(i))) return false;
	}
	return true;
}

function validate_nonumber(obj) {
	var val=obj.value;
	for(i=0;i<val.length;i++) {
        if("0123456789".indexOf(val.charAt(i))!=-1) return false;
	}
	return true;
}

function validate_login(obj) {
	var val=obj.value;
	for(i=0;i<val.length;i++) {
        	if(!val.match("^[\\w]+$")) return false;
//			if(!is_alnum2(val.charAt(i))) return false;
	}
	return true;
}

function validate_dirname(obj) {
	var val=obj.value;
	for(i=0;i<val.length;i++) {
        	if(!is_alnum2(val.charAt(i))) return false;
	}
	return true;
}

function validate_captcha(obj){
    return false;
}

function is_alpha(c) {
	if("qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM".indexOf(c)!=-1) return true;
	return false;
}

function is_number(c) {
	if("0123456789".indexOf(c)!=-1) return true;
	else return false;
}

function is_alnum(c) {
	if(is_alpha(c) || is_number(c)) return true;
	return false;
}

function is_alnum2(c) {
	if(is_alnum(c) || c=="_" || c=="-" || c==".") return true;
	return false;
}

function is_addsymb(c) {
	if("_-\.\ ".indexOf(c)!=-1) return true;
	else return false;
}
